<?php
/**
 * BitTools Platform | B2W - Companhia Digital
 *
 * Do not edit this file if you want to update this module for future new versions.
 *
 * @category  BitTools
 * @package   BitTools_SkyHub
 *
 * @copyright Copyright (c) 2018 B2W Digital - BitTools Platform.
 *
 * Access https://ajuda.skyhub.com.br/hc/pt-br/requests/new for questions and other requests.
 */

namespace BitTools\SkyHub\Controller\Adminhtml\Customer\Attributes\Mapping;

use BitTools\SkyHub\Api\CustomerAttributeMappingRepositoryInterface;
use BitTools\SkyHub\Helper\Context as HelperContext;
use Magento\Backend\App\Action\Context;

class Save extends AbstractMapping
{
    protected $_customerAttributesMapping;
    protected $_customerMappingRepository;

    /**
     * Save constructor.
     * @param Context $context
     * @param HelperContext $helperContext
     * @param CustomerAttributeMappingRepositoryInterface $customerAttributeMappingRepository
     * @param \BitTools\SkyHub\Model\Customer\Attributes\Mapping $customerAttributesMapping
     * @param \BitTools\SkyHub\Model\Customer\Attributes\MappingRepository $customerMappingRepository
     */
    public function __construct(
        Context $context,
        HelperContext $helperContext,
        CustomerAttributeMappingRepositoryInterface $customerAttributeMappingRepository,
        \BitTools\SkyHub\Model\Customer\Attributes\Mapping $customerAttributesMapping,
        \BitTools\SkyHub\Model\Customer\Attributes\MappingRepository $customerMappingRepository
    )
    {
        parent::__construct($context, $helperContext, $customerAttributeMappingRepository);

        $this->_customerAttributesMapping = $customerAttributesMapping;
        $this->_customerMappingRepository = $customerMappingRepository;
    }

    public function execute()
    {
        $customerMappingId = $this->getRequest()->getParam('id');
        $customerMapping = $this->_customerMappingRepository->get($customerMappingId);

        $magentoAttributeId = $customerMappingId = $this->getRequest()->getParam('attribute_id');
        if ($magentoAttributeId) {
            $customerMapping->setAttributeId($magentoAttributeId);
            $this->_customerMappingRepository->save($customerMapping);
            $this->messageManager->addNoticeMessage(__('The mapping was saved.'));
        }

        /** @var \Magento\Framework\Controller\Result\Redirect $redirectPage */
        $redirectPage = $this->resultFactory->create(\Magento\Framework\Controller\ResultFactory::TYPE_REDIRECT);
        $redirectPage->setPath('*/*/index');
        return $redirectPage;
    }
}